20 CLEAR:KEY OFF
30 COLOR 1,0:CLS:COLOR 15,1
40 PRINT"****************************************"
50 PRINT"*                                      *"
60 PRINT"* (c) 1986, Science Specialists Inc.   *"
70 PRINT"*                                      *"
80 PRINT"*       Polynomial Solving             *"
90 PRINT"*            Program                   *"
100 PRINT"*   (Bernoulli Method of Moments)      *"
101 PRINT"*                                      *"
110 PRINT"****************************************"
120 COLOR 15,0:PRINT
130 INPUT "ORDER OF POLYNOMIAL";N
140 DIM S(100),A(12),C(100),T(100)
150 FOR Q=0 TO N
160 PRINT"INPUT COEFFICIENT FOR S^";N-Q;"=";
170 INPUT A(Q):NEXT Q
171 PRINT"========================================"
172 FOR Q=0 TO N
175 IF Q>0 THEN A(Q)=A(Q)/A(0)
190 NEXT Q:A(0)=1
192 'FOR A=0 TO N:PRINT A,A(A):NEXT
195 S(0)=N-1
200 FOR P=1 TO 40:B=0
210 IF P>N THEN L=N:GOTO 270 ELSE L=P-1
220 B=-P*A(P):IF P=1 THEN 295
270 FOR Z=1 TO L
280 B=(-A(Z)*S(P-Z))+B
290 NEXT Z
295 S(P)=B:IF ABS(S(P))>1E+20 THEN 430
400 NEXT P
410 'PRINT N
430 IF (SGN(S(P-1))=SGN(S(P-3))) AND (SGN(S(P-2))=SGN(S(P-4))) THEN R=S(P-1)/S(P-2):PRINT"REAL ROOT=";R:GOTO 1000:GOTO 200  ELSE GOTO 2000
1000 '
1010 FOR Q=1 TO N
1020 A(Q)=+A(Q)+A(Q-1)*R
1025 NEXT
1027 IF ABS(A(N))>.001 THEN COLOR 15,7:Print"Warning this method may not be suitable"
1030 PRINT"AFTER DIVISION-REMAINDER=";A(N);
1035 COLOR 15,0:print
1040 N=N-1:IF N=1 THEN PRINT"REAL ROOT=";-A(1)/A(0):GOTO 2222
1045 IF N<1 THEN STOP
1060 GOTO 172
2000 A=(S(P-3)^2-S(P-2)*S(P-4))
2005 IF A=0 THEN PRINT"NO SOLUTION BY THIS METHOD" :STOP
2010 B=-S(P-2)*S(P-3)+S(P-1)*S(P-4):B=B/A
2020 C=((S(P-2))^2-S(P-3)*S(P-1)):C=C/A:A=1
2025 REAL=-B/(2*A):IMAG=SQR(ABS(B^2-4*A*C))/(2*A)
2030 PRINT"IMAGINARY ROOT=";-B/(2*A);"   +J";SQR(ABS(B^2-4*A*C))/(2*A)
2040 PRINT"IMAGINARY ROOT=";-B/(2*A);"   -J";SQR(ABS(B^2-4*A*C))/(2*A)
2050 A=-2*REAL:B=REAL^2+IMAG^2
2060 FOR Q=1 TO N-1
2070 A(Q)=A(Q)-A(Q-1)*A
2080 A(Q+1)=A(Q+1)-A(Q-1)*B
2090 NEXT Q
2091 IF ((ABS(A(N))>.001) OR (ABS(A(N-1))>.001)) THEN COLOR 15,7:print"Warning: ";
2092 IF A(N)>0 THEN 2095 ELSE 2096
2095 PRINT"REMAINDER=(";A(N-1);"*S + ";A(N);")":GOTO 2097
2096 PRINT"REMAINDER=(";A(N-1);"*S - ";ABS(A(N));")"
2097 COLOR 15,0
2100 N=N-2
2104 IF N=1 THEN PRINT"REAL ROOT=";-A(1)/A(0):GOTO 2222
2105 IF N<1 THEN 2222
2110 GOTO 172
2115 IF N=0 THEN 2222
2222 PRINT"========================================":INPUT"NEW DATA";FA$:IF INSTR("NoNOnOno",FA$)<1 THEN 20
