5 DIM A#(20),B#(20)
6 RF=1
10 GOSUB 1000
20 PI#=3.141592653589#
30 GOSUB 1120
35 LOCATE 3,52:PRINT"ITERATION"
40 '************** NEWTON REDUCTION ***************
70 SR#=.2:CR#=1:CI#=0:FLAG=0:START=1:LOCATE 6,52:PRINT"N"
80 GOSUB 170:GOSUB 270:SOQ#=SQ#
90 CR#=CR#+SR#:GOSUB 170:GOSUB 270:ITER=ITER+1
100 IF SOQ#<SQ# THEN FLAG=0 ELSE FLAG=FLAG+1
110 IF FLAG=0 THEN IF START=1 THEN START=0 ELSE GOTO 400
140 SR#=SQ#/((SOQ#-SQ#)/SR#):IF ABS(SQ#-SOQ#)<1E-12 THEN 260
145 '************** CALCULATE Y  *******************
150 IF ABS(SR#)<.000001 THEN 260
160 SOQ#=SQ#:GOTO 90
170 SUMR#=0:SUMI#=0
180 FOR J=0 TO N
190 R#=SQR(CR#^2+CI#^2)
200 IF CR#=0 THEN IF CI#>0 THEN ANG#=PI#/2 ELSE ANG#=-PI#/2 ELSE ANG#=ATN(CI#/CR#):IF CR#<0 THEN ANG#=ANG#+PI#
210 SUMR#=A#(J)*R#^J*COS(ANG#*J)+SUMR#
220 SUMI#=A#(J)*R#^J*SIN(ANG#*J)+SUMI#
230 NEXT J
240 SQ#=SQR(SUMI#^2+SUMR#^2):LOCATE 4,50:PRINT"                              ":LOCATE 4,50:PRINT USING "###. ##.####,##.####"; ITER,CR#,CI#
250 RETURN
260 IF ABS(SQ#)>.000001 THEN 290 ELSE 390
270 SQ#=SQR(SUMR#^2+SUMI#^2):IF SQ#<.000001 THEN RETURN 260 ELSE RETURN
280 SOQ#=SQR(SOR#^2+SOI#^2):RETURN
285 '************** SEARCH FOR COMPLEX ROOT ********
290 SR#=.2:CI#=1:ITER=0:START=1:LOCATE 6,52:PRINT"C"
300 GOSUB 170:GOSUB 270
310 SOQ#=SQ#:ITER=ITER+1
320 CI#=CI#+SR#:GOSUB 170:GOSUB 270
330 IF SOQ#<SQ# THEN FLAG=0 ELSE FLAG=FLAG+1
340 IF FLAG=0 THEN SR#=-SR#/2.0010010001#
350 IF FLAG>2 THEN SR#=SR#*3.1415926535#
360 IF (ABS(SOQ#-SQ#)<1E-09) THEN 390
370 IF ABS(SR#)<.000001  THEN 390
380 GOTO 310
390  LOCATE 6,52:PRINT" ":GOSUB 1330:GOTO 40
395 '************** NON-NEWTONIAN SEARCH ***********
400 SR#=.2:FLAG=0:ITER=0:SQ#=0:SOQ#=0:LOCATE 6,52:PRINT"R"
410 CR#=CR#+SR#:GOSUB 170:ITER=ITER+1
420 IF SOQ#<SQ# THEN FLAG=0 ELSE FLAG=FLAG+1
430 IF FLAG=0 THEN SR#=-SR#/2.1010100001#
440 IF FLAG>3 THEN SR#=SR#*3.1415926535#
450 IF  (ABS(SQ#-SOQ#)<1E-09) THEN 500
470 IF ABS(SR#)<.0000001 THEN 260
480 SOQ#=SQ#:GOTO 410
490 SUMR#=0:SUMI#=0
500 GOSUB 1260:IF ABS(RMDR#)>.0001 THEN 290 ELSE GOSUB 1320:GOTO 70
1000 KEY OFF
1010 COLOR 1,0:CLS:COLOR 15,1
1020 PRINT"****************************************"
1030 PRINT"*                                      *"
1040 PRINT"* (c) 1986, Science Specialists Inc.   *"
1050 PRINT"*                                      *"
1060 PRINT"*       Polynomial Solving             *"
1070 PRINT"*            Program                   *"
1080 PRINT"*       (Iterative method)             *"
1090 PRINT"*                                      *"
1100 PRINT"****************************************"
1110 COLOR 15,0:PRINT:RETURN
1120 INPUT "ORDER OF POLYNOMIAL";N
1140 FOR Q=N TO 0 STEP -1
1150 PRINT"INPUT COEFFICIENT FOR S^";Q;"=";
1160 INPUT A#(Q):NEXT
1162 RF=CSRLIN:IF N=2 THEN 1800
1165 RETURN
1170 '********** reduce to standard form *********
1180 FOR Q=N-1 TO 0 STEP -1
1190 IF Q>0 THEN A#(Q)=A#(Q)/A#(N)
1200 NEXT Q:A#(N)=1
1220 S(0)=N-1
1230 '********** REMAINDER CHECK     *************
1240 '
1250 '
1260  FOR J=0 TO N:B#(J)=A#(J):NEXT:JAZZ=1:GOSUB 1360:JAZZ=0
1270  FOR J=0 TO N:A#(J)=B#(J):NEXT
1280  RETURN
1290    '
1320  '****************** PRINT OUT ROUTINE ********************
1330  CPLEX=0:'IS THE ROOT COMPLEX
1340  IF ABS(CI#)>.00001 THEN CPLEX=1:GOTO 1344
1341  GOSUB 1260
1343  IF ABS(RMDR#)>.0001 THEN CPLEX=1 ELSE CPLEX=0
1344  LOCATE RF,1:IF CPLEX=1 THEN GOSUB 1430 ELSE ER=CR#:PRINT "REAL ROOT=";ER;:RF=RF+1:GOSUB 1360:N=N-1:GOSUB 1400
1345  CI#=0:CR#=0:IF N=2 THEN 1800 ELSE RETURN
1346 '
1350 '*** Reduce Equation by division ************
1360 FOR Q=N-1 TO 0 STEP -1
1370 A#(Q)=A#(Q)+A#(Q+1)*CR#
1380 NEXT:RMDR#=A#(0):RDM=RMDR#:IF JAZZ=0 THEN PRINT"     REMAINDER=";RDM
1390 FOR Q=1 TO N :A#(Q-1)=A#(Q):NEXT:RETURN
1400 IF N=1 THEN LOCATE RF,1:EW=-A#(0)/A#(1):PRINT "REAL ROOT=";EW:RF=RF+1:GOTO 1700
1410 IF N<1 THEN GOTO 1700
1420 RETURN
1430 '******** extract imaginary roots ***********
1480 REAL#=CR#:IMAG#=CI#
1490 LOCATE RF,1:ER=REAL#:EI=IMAG#:PRINT "COMPLEX ROOT=";ER;"   +J";ABS(EI)
1500 PRINT "COMPLEX ROOT=";ER;"   -J";ABS(EI);:RF=RF+2
1510 A#=-2*REAL#:B#=REAL#^2+IMAG#^2
1520 '******** reduce equation size by division **
1530 FOR Q=N-1 TO 1 STEP -1
1540 A#(Q)=A#(Q)-A#(Q+1)*A#
1550 A#(Q-1)=A#(Q-1)-A#(Q+1)*B#
1560 NEXT Q:A#(N)=1:WR1=A#(1):WR2=A#(0):PRINT " RMDR=(S*";WR1;" ";WR2;")"
1570 N=N-2:FOR Q=0 TO N:A#(Q)=A#(Q+2):NEXT
1580 IF N=1 THEN LOCATE RF,1:ER=A#(0):EI=A#(1):PRINT "REAL ROOT=";-ER/EI:GOTO 1700
1590 IF N<1 THEN 1700
1600 RETURN
1610 IF N=0 THEN GOTO 1700
1700 COLOR 15,14:LOCATE  1,52:INPUT"NEW DATA";A$:COLOR 15,0:IF INSTR("nNnoNO",A$)=0 THEN 10
1710 LOCATE 1,1:STOP
1800 LOCATE RF,1:D=A#(1)^2-4*A#(2)*A#(0)
1900 IF D=>0 THEN ER=(-A#(1)+SQR(D))/(2*A#(2)):EI=0:GOSUB 2000:ER=(-A#(1)-SQR(D))/(2*A#(2)):GOSUB 2000
1910 IF D<0 THEN ER=(-A#(1))/(2*A#(2)):EI=SQR(ABS(D))/(2*A#(2)):GOSUB 2100
1920 GOTO 1700
2000 PRINT"REAL ROOT=";ER:RETURN
2100 PRINT "COMPLEX ROOT=";ER;"   +J";ABS(EI)
2200 PRINT "COMPLEX ROOT=";ER;"   -J";ABS(EI):RETURN
